local TOCNAME,BOM=...
local L = setmetatable({}, {__index = function (t, k)  
	if BOM.L and BOM.L[k] then 
		return BOM.L[k]
	else
		return "["..k.."]"
	end	
end})

local ResurrectionClass={ "SHAMAN", "PRIEST", "PALADIN" }
local ManaClass={  "HUNTER", "WARLOCK", "MAGE", "DRUID", "SHAMAN", "PRIEST", "PALADIN"  }
local MAXMANA=999999

BOM.ProfileNames={"solo","group","raid","battleground"}


BOM.ArgentumDawn={
	spell=17670,
	dungeon={329,289},--Stratholme/scholomance
}
BOM.Carrot={
	spell=13587,
	dungeon={0,1},--Eastern Kingdoms, Kalimdor
}

BOM.EnchantList={--weapon-echantment to spellid
	[16342]={3,4,5,523,1665,1666},--Flametongue
	[16356]={2,12,524,1667,1668},--Frostbrand
	[16316]={1,6,29,503,683,1663,1664},--Rockbiter
	[16362]={283,284,525,1669},--Windfury
}

BOM.BuffExchangeId={ -- comine-spell-ids to new one
	[18788]={18791,18790,18789,18792}, -- Demonic Sacrifice-Buffs to Demonic Sacrifice
}

BOM.SpellToSpell={}
for dest,list in pairs(BOM.BuffExchangeId) do
	for i,id in ipairs(list) do
		BOM.SpellToSpell[id]=dest
	end
end

BOM.EnchantToSpell={}
for dest,list in pairs(BOM.EnchantList) do
	for i,id in ipairs(list) do
		BOM.EnchantToSpell[id]=dest
	end
end

BOM.ItemList={
	--{6948},--Ruhestein
	--{4604},--Waldpilz
	{5232,16892,16893,16895,16896}, -- Seelenstein
}

BOM.CancelBuffs={
	{singleId=10901, default=false,--Powerword:Shild
		singleFamily={17,592,600,3747,6065,6066,10898,10899,10900,10901}},
	
	--{singleId=10952, OnlyCombat=true, default=true, --demo
	--	singleFamily={588,7128,602,1006,10951,10952}}, 
		
}
do 
	local _,class,_ UnitClass("unit")
	if class=="HUNTER" then
		tinsert(BOM.CancelBuffs,
			{singleId=5118, OnlyCombat=true, default=true, --Aspect of the Cheetah--Aspect of the pack
				singleFamily={5118,13159}}
		)	
	end
	if (UnitFactionGroup("player"))~="Horde" then
		tinsert(BOM.CancelBuffs,
			{singleId=1038, default=false,--Blessing of Salvation
				singleFamily={1038,25895}}
		)	
	end
end

BOM.BuffIgnoreAll={4511}

local ShapeShiftTravel={2645,783}--Ghost wolf and travel druid

BOM.SpellList={	
	"PRIEST",
	{singleId=10938, groupId=21562, default=true, -- seelenstärke
		singleFamily={1243,1244,1245,2791,10937,10938},groupFamily={21562,21564},
		singleDuration=1800,groupDuration=3600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=14819, groupId=27681, default=true,	-- willenstärke
		singleFamily={14752,14818,14819,27841},
		singleDuration=1800,groupDuration=3600,
		classes={ "MAGE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=10958, groupId=27683, default=false, --schattenschutz
		singleFamily={976,10957,10958},
		singleDuration=600,groupDuration=1200,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=6346, default=false, -- fearward
		singleDuration=600,hasCD=true,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=10901, default=false, -- Powerword:Shild
		singleFamily={17,592,600,3747,6065,6066,10898,10899,10900,10901},
		singleDuration=30,hasCD=true,
		classes={ }},		
	{singleId=19266, default=true, isOwn=true}, --Berührung der Schwäche
	{singleId=10952, default=true, isOwn=true,   --inneres Feuer
		singleFamily={588,7128,602,1006,10951,10952}}, 
	{singleId=19312, default=true, isOwn=true, --shadowguard
		singleFamily={18137,19308,19309,19310,19311,19312}},
	{singleId=19293,default=true,isOwn=true,--Elune's Grace
		singleFamily={2651,19289,19291,19292,19293}},
	
	{singleId=20770, isResurrection=true, default=true, --Auferstehung	
		singleFamily={2006,2010,10880,10881,20770}},
		
	"DRUID",
	{singleId=9885, groupId=21849, cancelForm=true, default=true,--Gabe/Mal der Wildniss
		singleFamily={1126,5232,6756,5234,8907,9884,9885},groupFamily={21849,21850},
		singleDuration=1800,groupDuration=3600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }}, 
	{singleId=9910, cancelForm=true, default=false,--Dornen
		singleFamily={467,782,1075,8914,9756,9910},
		singleDuration=600,
		classes={ "WARRIOR", "ROGUE", "DRUID", "SHAMAN", "PALADIN" }},
	{singleId=16864, isOwn=true, cancelForm=true, default=true}, --omen of clarity
	{singleId=17329, isOwn=true, cancelForm=true, default=false,	 -- Griff der Natur
		hasCD=true,NeedOutdoors=true,
		singleFamily={16689,16810,16811,16812,16813,17329},	
	},
	{singleId=5225, isTracking=true, needForm=CAT_FORM, default=true}, -- search human
	
	"MAGE",
	{singleId=10157, groupId=23028, default=true,	-- arkane intelligenz
		singleFamily={1459,1460,1461,10156,10157},
		singleDuration=1800,groupDuration=3600,
		classes={ "MAGE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=10174, default=false, --Dampen Magic
		singleDuration=600,classes={ },
		singleFamily={604,8450,8451,10173,10174}},	
	{singleId=10170, default=false, --Amplify Magic
		singleDuration=600,classes={ },
		singleFamily={1008,8455,10169,10170}},
	{singleId=10220, isSeal=true, default=false, --eisrüstung
		singleFamily={7302,7320,10219,10220}},
	{singleId=7301, isSeal=true, default=false, --frostrüstung
		singleFamily={168,7300,7301}},
	{singleId=22783, isSeal=true, default=false, --magische rüstung
		singleFamily={6117,22782,22783}},
	{singleId=10193, isOwn=true, default=false, --Manaschild - unabhängig von allen.
		singleDuration=60,
		singleFamily={1463,8494,8495,10191,10192,10193}},
	{singleId=10054, isOwn=true, default=true, ItemLock={5514,5513,8007,8008}, -- manastone
		singleFamily={759,3552,10053,10054}},

	"SHAMAN",
	{singleId=16342, isSeal=true, default=true,singleDuration=500,--Flametongue
		singleFamily={8024,8027,8030,16339,16341,16342}},
	{singleId=16356, isSeal=true, default=true,singleDuration=500,--Frostbrand
		singleFamily={8033,8038,10456,16355,16356}},
	{singleId=16316, isSeal=true, default=true,singleDuration=500,--Rockbiter
		singleFamily={8017,8018,8019,10399,16314,16315,16316}},		
	{singleId=16362, isSeal=true, default=true,singleDuration=500,--Windfury 
		singleFamily={8232,8235,10486,16362}},		
	{singleId=10432, isOwn=true, default=true,--Blitzschlagschild
		singleFamily={324,325,905,945,8134,10431,10432}},
	{singleId=20777, isResurrection=true, default=true, --Auferstehung	
		singleFamily={2008,20609,20610,20776,20777}},
	
	"WARLOCK",
	{singleId=5697, default=false, -- Unending Breath
		singleDuration=600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=11743, default=false, -- Große Unsichtbarkeit entdecken
		singleFamily={132,2970,11743},
		singleDuration=600,
		classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }},
	{singleId=28610, isOwn=true, default=false, --Schattenzauberschutz
		singleFamily={6229,11739,11740,28610}},
	{singleId=11735, isOwn=true, default=false, -- Demon Armor
		singleFamily={706,1086,11733,11734,11735}},
	{singleId=696, isOwn=true, default=false, -- Demon skin
		singleFamily={687,696}},	
	{singleId=18788, isOwn=true, default=true}, -- Demonic Sacrifice
	{singleId=17953, isOwn=true, default=false, ItemLock={1254,13699,13700,13701}, -- Firestone 
		singleFamily={6366,17951,17952,17953}},
	{singleId=11730, isOwn=true, default=true, ItemLock={5512,19005,19004,5511,19007,19006,5509,19009,19008,5510,19011,19010,9421,19013,19012},-- Healtstone
		singleFamily={6201,6202,5699,11729,11730}},
	{singleId=20757, isOwn=true, default=true, ItemLock={5232,16892,16893,16895,16896},--Soulstone
		singleFamily={693,20752,20755,20756,20757}},
	
	{singleId=5500, isTracking=true, default=true}, --Sense Demons
	
	"HUNTER",
	{singleId=20906, isOwn=true, default=true, -- Trueshot Aura
		singleFamily={19506,20905,20906}},
		
	{singleId=13161, isAura=true, default=true}, -- Aspect of the beast
	{singleId=25296, isAura=true, default=true, --Aspect of the Hawk
		singleFamily={13165,14318,14319,14320,14321,14322,25296}},	
	{singleId=13163, isAura=true, default=true}, --Aspect of the monkey
	{singleId=20190, isAura=true, default=true, --Aspect of the wild
		singleFamily={20043,20190}},
	{singleId=5118,  isAura=true, default=false}, --Aspect of the Cheetah
	{singleId=13159, isAura=true, default=false}, --Aspect of the pack
		
	{singleId=1494,  isTracking=true, default=true}, --beast
	{singleId=19878, isTracking=true, default=true}, --dämonen
	{singleId=19879, isTracking=true, default=true}, --drachkin
	{singleId=19880, isTracking=true, default=true}, --elementare
	{singleId=19883, isTracking=true, default=true}, --humanoide
	{singleId=19882, isTracking=true, default=true}, --riesen
	{singleId=19884, isTracking=true, default=true}, --untote
	{singleId=19885, isTracking=true, default=true}, --verborgenes
	
	"PALADIN",
	{singleId=25780, isOwn=true, default=true}, --Righteous Fury
	
	{singleId=20217, groupId=25898, isBlessing=true, default=true, --Blessing of Kings 
		singleDuration=300,groupDuration=900,
		classes={  "MAGE", "HUNTER", "WARLOCK" }},
	{singleId=19979, groupId=25890, isBlessing=true, default=true,--Blessing of Light 
		singleFamily={19977,19978,19979},
		singleDuration=300,groupDuration=900,
		classes={}},
	{singleId=25291, groupId=25916, isBlessing=true, default=true,--Blessing of Might 
		singleFamily={19740,19834,19835,19836,19837,19838,25291},groupFamily={25782,25916},
		singleDuration=300,groupDuration=900,
		classes={ "WARRIOR", "ROGUE"}},
	{singleId=1038, groupId=25895, isBlessing=true, default=true,--Blessing of Salvation
		singleDuration=300,groupDuration=900,
		classes={ }},		
	{singleId=20914, groupId=25899, isBlessing=true, default=true,--Blessing of Sanctuary 
		singleFamily={20911,20912,20913,20914},
		singleDuration=300,groupDuration=900,
		classes={ }},
	{singleId=25290, groupId=25918, isBlessing=true, default=true,--Blessing of Wisdom -
		singleFamily={19742,19850,19852,19853,19854,25290},groupFamily={25894,25918},
		singleDuration=300,groupDuration=900,
		classes={ "DRUID",  "SHAMAN", "PRIEST", "PALADIN" }},
 
	{singleId=10293, isAura=true, default=true, -- Devotion Aura
		singleFamily={465,10290,643,10291,1032,10292,10293}},
	{singleId=10301, isAura=true, default=true, -- Retribution Aura
		singleFamily={7294,10298,10299,10300,10301}},
	{singleId=19746, isAura=true, default=true},--Concentration Aura
	{singleId=19896, isAura=true, default=true, -- Shadow Resistance Aura
		singleFamily={19876,19895,19896}},
	{singleId=19898, isAura=true, default=true, -- Frost Resistance Aura
		singleFamily={19888,19897,19898}},	
	{singleId=19900, isAura=true, default=true, -- Fire Resistance Aura
		singleFamily={19891,19899,19900}},
	{singleId=20218, isAura=true, default=true},--Sanctity Aura
	{singleId=20773, isResurrection=true, default=true, --Auferstehung	
		singleFamily={7328,10322,10324,20772,20773}},	
	
	{singleId=20164, isSeal=true, default=false}, -- Sanctity seal
	{singleId=20165, isSeal=true, default=false}, -- Seal of Light
	{singleId=20154, isSeal=true, default=false}, --Seal of Righteousness
	{singleId=21084, isSeal=true, default=false}, --Seal of Righteousness		
	{singleId=20166, isSeal=true, default=false}, --Seal of Wisdom
		
	{singleId=5502, isTracking=true, default=true}, --sense undead
		
	"TRACKING",	
	{singleId=2383, isTracking=true, default=true}, --kräuter
	{singleId=2580, isTracking=true, default=true}, -- erz
	{singleId=2481, isTracking=true, default=true}, -- Schatzsuche / Zwerge
	
	"INFO",
	{singleId=432, isInfo=true, default=false,	--drink
		singleFamily={430,431,432,1133,1135,1137,22734,25696,26475,26261,29007,26473,10250,26402}},
	{singleId=434, isInfo=true, default=false,	--essen
		singleFamily={10256,1127,1129,22731,5006,433,1131,18230,18233,5007,24800,5005,18232,5004,435,434,18234,24869,18229,25888,6410,2639,24005,7737,29073,26260,26474,18231,10257,26472,28616,25700}},
	{singleId=20762, isInfo=true, default=false,	--Seelenstein
		singleFamily={20707,20762,20763,20765,20764}},
	
}

function BOM.CancelBuff(list)
	local ret=false
	if not InCombatLockdown() and list then
		for i=1,40 do
			   --name, icon, count, debuffType, duration, expirationTime, source, isStealable, nameplateShowPersonal, spellId,
			local _  ,  _  , _    , _         , _       , _             , source, _          , _                    , spellId = UnitBuff("player",i,"CANCELABLE")
			if tContains(list,spellId) then
				ret=true
				BOM.CancelBuffSource=source or "player"
				CancelUnitBuff("player", i)
				break
			end
		end
	end
	return ret
end

function BOM.CancelShapeShift()
	return BOM.CancelBuff(ShapeShiftTravel)	
end


function BOM.HasItem(list,cd)
	for bag=BACKPACK_CONTAINER , NUM_BAG_SLOTS do
		for slot=1,GetContainerNumSlots(bag) do
			local itemID = GetContainerItemID(bag,slot)
			if tContains(list,itemID) then				
				return true
			end
		end
	end
	return false
end

function BOM.GetItemList(ItemList,cd)
	local items={}	
	
	for bag=BACKPACK_CONTAINER , NUM_BAG_SLOTS do
		for slot=1,GetContainerNumSlots(bag) do
			--local itemID = GetContainerItemID(bag,slot)
			
			local icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID = GetContainerItemInfo(bag, slot)
			
			for iList,list in ipairs(ItemList) do
				if tContains(list,itemID) then
					tinsert(items,{Index=iList,ID=itemID,CD={ GetContainerItemCooldown(bag,slot)},Link=itemLink,Bag=bag,Slot=slot,Texture=icon}	)				
				end
			end
			
			if lootable and BOM.DB.OpenLootable then
				local locked=false
				for i,text in ipairs(BOM.Tool.ScanToolTip("SetBagItem",bag,slot)) do
					if text==LOCKED then
						locked=true
						break
					end
				end
				if not locked then 
					tinsert(items,{Index=0,ID=itemID,CD=nil,Link=itemLink,Bag=bag,Slot=slot,Lootable=true,Texture=icon}	)
				end
										
			end
			
		end
	end
	return items
end

local function SpellLinkFormat(spellId,icon,name,rank)
	--local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell)
	if spellId==nil then
		return "NIL SPELLID"
	else
		rank=rank or "MISSING RANK"
		name = name or "MISSING NAME"
		icon = icon or "MISSING ICON"
		if rank~="" then
			rank="("..rank..")"
		end
		rank=""
		return "|Hspell:" .. spellId .."|h|r |cff71d5ff" ..string.format(BOM.TxtEscapeIcon,icon).. name..rank.."|r|h"
	end
end
local function SpellLink(spell)
	local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell)
	--print ("GETLINK",spell,name,rank,icon,castTime,minRange,maxRange,spellId)
	return SpellLinkFormat(spellId,icon,name)
end

function BOM.GetSpells()
	for i,profil in ipairs(BOM.ProfileNames) do
		BOM.DBChar[profil].Spell=BOM.DBChar[profil].Spell or {}
		BOM.DBChar[profil].CancelBuff=BOM.DBChar[profil].CancelBuff or {}
		BOM.DBChar[profil].Spell[BOM.BLESSINGID] = BOM.DBChar[profil].Spell[BOM.BLESSINGID] or {}
	end
	
	BOM.Spells={}
	BOM.cancelForm={}
	BOM.AllSpellIds={}
	BOM.SpellIdtoConfig={}
	BOM.SpellIdIsSingle={}
	BOM.ConfigToSpell={}
	
	txt=""
	
	do
		local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(BOM.ArgentumDawn.spell)
		BOM.ArgentumDawn.Link=SpellLinkFormat(spellId,icon,name,rank)
		name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(BOM.Carrot.spell)
		BOM.Carrot.Link=SpellLinkFormat(spellId,icon,name,rank)
	end
	
	for i,spell in ipairs(BOM.CancelBuffs) do
		
		-- save "ConfigID"
		spell.ConfigID=spell.ConfigID or spell.singleId
		if spell.singleFamily then
			for sindex,sID in ipairs(spell.singleFamily) do
				BOM.SpellIdtoConfig[sID]=spell.ConfigID
			end
		end
		
		-- GetSpellNames and set default duration
		local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell.singleId)				
		spell.single=name
		rank=GetSpellSubtext(spell.singleId) or ""
		spell.singleLink=SpellLinkFormat(spellId,icon,name,rank)
		spell.Icon=icon
		
		BOM.Tool.iMerge(BOM.AllSpellIds,spell.singleFamily)
		
		for i,profil in ipairs(BOM.ProfileNames) do
			if BOM.DBChar[profil].CancelBuff[spell.ConfigID]==nil then 
				BOM.DBChar[profil].CancelBuff[spell.ConfigID]={}
				BOM.DBChar[profil].CancelBuff[spell.ConfigID].Enable=spell.default or false				
			end		
		end
	end
	
	
	for i,spell in ipairs(BOM.SpellList) do
		
		if type(spell)=="table" then		
			
			-- save "ConfigID"
			spell.ConfigID=spell.ConfigID or spell.singleId
			spell.SkipList={}
			BOM.ConfigToSpell[spell.ConfigID]=spell
			
			-- get highest rank and store SpellID=ConfigID
			if spell.singleFamily then
				for sindex,sID in ipairs(spell.singleFamily) do
					BOM.SpellIdtoConfig[sID]=spell.ConfigID
					BOM.SpellIdIsSingle[sID]=true
					BOM.ConfigToSpell[sID]=spell
					if IsSpellKnown(sID) then
						spell.singleId=sID
					end
				end				
			end
			if spell.singleId then
				BOM.SpellIdtoConfig[spell.singleId]=spell.ConfigID
				BOM.SpellIdIsSingle[spell.singleId]=true
				BOM.ConfigToSpell[spell.singleId]=spell
			end
			if spell.groupFamily then
				for sindex,sID in ipairs(spell.groupFamily) do
					BOM.SpellIdtoConfig[sID]=spell.ConfigID
					BOM.ConfigToSpell[sID]=spell
					if IsSpellKnown(sID) then
						spell.groupId=sID
					end
				end
			end
			if spell.groupId then
				BOM.SpellIdtoConfig[spell.groupId]=spell.ConfigID
				BOM.ConfigToSpell[spell.groupId]=spell
			end
			
			-- GetSpellNames and set default duration
			if spell.singleId then
				local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell.singleId)				
				spell.single=name
				rank=GetSpellSubtext(spell.singleId) or ""
				spell.singleLink=SpellLinkFormat(spellId,icon,name,rank)
				spell.Icon=icon
				if spell.isTracking then
					spell.TrackingIcon=icon
				end
				if not spell.isInfo and spell.singleDuration and BOM.DB.Duration[name]==nil and IsSpellKnown(spell.singleId)then 
					BOM.DB.Duration[name]=spell.singleDuration
				end
			end
			if  spell.groupId then
				local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spell.groupId)
				spell.group=name
				rank=GetSpellSubtext(spell.groupId) or ""
				spell.groupLink=SpellLinkFormat(spellId,icon,name,rank)
				if spell.groupDuration and BOM.DB.Duration[name]==nil and IsSpellKnown(spell.groupId) then 
					BOM.DB.Duration[name]=spell.groupDuration
				end				
			end
		
			if spell.single and spell.group then
				txt=txt.. spell.single .." / "..spell.group.."\n"
			else
				txt=txt.. spell.single .."\n"
			end
		
			-- has Spell? Manacost?
			local add
			if IsSpellKnown(spell.singleId) then
				add=true
				spell.singleMana=0
				local cost=GetSpellPowerCost(spell.single)
				if type(cost)=="table"  then
					for i=1,#cost do
						if cost[i] and cost[i].name=="MANA" then 
							spell.singleMana=cost[i].cost or 0
						end
					end
				end
			end
			if spell.group and IsSpellKnown(spell.groupId) then
				add=true
				spell.groupMana=0
				local cost=GetSpellPowerCost(spell.group)		
				if type(cost)=="table"  then
					for i=1,#cost do
						if cost[i] and cost[i].name=="MANA" then 
							spell.groupMana=cost[i].cost or 0
						end
					end
				end
			end
			
			if spell.isInfo then
				add=true
			end
			
			-- Add 
			if add then
				tinsert(BOM.Spells,spell)
				BOM.Tool.iMerge(BOM.AllSpellIds,spell.singleFamily, spell.groupFamily, spell.singleId, spell.groupId)
								
				if spell.cancelForm then
					BOM.Tool.iMerge(BOM.cancelForm,spell.singleFamily, spell.groupFamily, spell.singleId, spell.groupId)
				end
				
				--setDefaultValues!
				for i,profil in ipairs(BOM.ProfileNames) do
					
					if BOM.DBChar[profil].Spell[spell.ConfigID]==nil then 
						BOM.DBChar[profil].Spell[spell.ConfigID]={}
						BOM.DBChar[profil].Spell[spell.ConfigID].Class=BOM.DBChar[profil].Spell[spell.ConfigID].Class or {}
						BOM.DBChar[profil].Spell[spell.ConfigID].ForcedTarget=BOM.DBChar[profil].Spell[spell.ConfigID].ForcedTarget or {}
					
						BOM.DBChar[profil].Spell[spell.ConfigID].Enable=spell.default or false
						
						if BOM.SpellHasClasses(spell) then
							local SelfCast=true
							BOM.DBChar[profil].Spell[spell.ConfigID].SelfCast=false
							for ci,class in ipairs(BOM.Tool.Classes) do
								BOM.DBChar[profil].Spell[spell.ConfigID].Class[class]=tContains(spell.classes,class)
								SelfCast=BOM.DBChar[profil].Spell[spell.ConfigID].Class[class] and false or SelfCast
							end
							BOM.DBChar[profil].Spell[spell.ConfigID].ForcedTarget={}
							BOM.DBChar[profil].Spell[spell.ConfigID].SelfCast= SelfCast
						end
					else
						BOM.DBChar[profil].Spell[spell.ConfigID].Class=BOM.DBChar[profil].Spell[spell.ConfigID].Class or {}
						BOM.DBChar[profil].Spell[spell.ConfigID].ForcedTarget=BOM.DBChar[profil].Spell[spell.ConfigID].ForcedTarget or {}
					
					end
					
				end
			end	
		else
			txt=txt.."\n"..spell.."\n"
		end		
	end
	--BOM.DBChar.DEBUGOUT=txt
end

local MemberCache={}

local function GetMember(unitid,NameGroup,NameRole)
	
	local name=(UnitFullName(unitid))
	if name==nil then return nil end
	
	local group=NameGroup and NameGroup[name] or 1
	local isTank=NameRole and (NameRole[name]=="MAINTANK") or false
	
	local guid = UnitGUID(unitid)
	local _, class,link
	if guid then
		 _ , class = GetPlayerInfoByGUID(guid)
		if class then
			link=BOM.Tool.IconClass[class].."|Hunit:"..guid..":"..name.."|h|c"..RAID_CLASS_COLORS[class].colorStr ..name.."|r|h"	
		else
			class=""
			link=string.format(BOM.TxtEscapeIcon,BOM.IconPet) ..  name
		end
	else
		class=""
		link=string.format(BOM.TxtEscapeIcon,BOM.IconPet) ..  name
	end	
	
	MemberCache[unitid]=MemberCache[unitid] or {}
	member=MemberCache[unitid]
	member.distance=100000
	member.unitId=unitid
	member.name=name
	member.group=group
	member.hasResurrection=false
	member.class=class
	member.link=link
	member.isTank=isTank
	return member
end

local savedParty,savedPlayerMember 
local buffCache={}
local function NumMember()
	local countTo
	local prefix
	local count
	if IsInRaid() then
		countTo=40
		prefix="raid"
		count=0
	else
		countTo=4
		prefix="group"
		if UnitPlayerOrPetInParty("pet") then
			count=2
		else
			count=1
		end
	end
	
	for i=1,countTo do
		if UnitPlayerOrPetInParty(prefix..i) then
			count=count+1
			if UnitPlayerOrPetInParty(prefix.."pet"..i) then
				count=count+1
			end
		end
	end
	
	return count
end

function BOM.GetPartyMembers() -- and buffs
	
	local party
	local playerMember

	if not BOM.PartyUpdateNeeded and savedParty~=nil and savedPlayerMember~=nil then
		
		if #savedParty==NumMember() + (BOM.SaveTargetName and 1 or 0) then 
			local ok=true
			for i,member in ipairs(savedParty) do
				local name=(UnitFullName(member.unitId))
				if name~=member.name then
					ok=false
					break
				end
			end		
			if ok then 
				party=savedParty
				playerMember=savedPlayerMember 
			end
		end
	end
	
	if party==nil or playerMember==nil then
		party={}
	
		if IsInRaid() then 
			local NameGroup={}
			local NameRole={}

			for raidIndex=1,40 do
				local name, rank, subgroup, level, class, fileName, 
						zone, online, isDead, role, isML, combatRole = GetRaidRosterInfo(raidIndex)
				
				if name then
					name=BOM.Tool.Split(name,"-")[1]
					NameGroup[name]=subgroup
					NameRole[name]=role
				end
			end
			
			for raidIndex=1,40 do
				local member=GetMember("raid"..raidIndex,NameGroup,NameRole)
				if member then 
					if UnitIsUnit(member.unitId,"player") then
						playerMember=member
					end
					tinsert(party,member)
				
					member=GetMember("raidpet"..raidIndex)
					if member then
						member.group=9
						member.class="pet"
						tinsert(party,member)				
					end
				end
			end

		else
			local  member
			for groupIndex=1,4 do
				member=GetMember("party"..groupIndex)
				if member then 
					tinsert(party, member )
				end
				member=GetMember("partypet"..groupIndex)
				if member then
					member.group=9
					member.class="pet"
					tinsert(party,member)				
				end				
			end				
			playerMember=GetMember("player")
			tinsert(party,playerMember)
			member=GetMember("pet")
			if member then
				member.group=9
				member.class="pet"
				tinsert(party,member)
			end
		end
		
		if BOM.DB.BuffTarget and UnitExists("target") and UnitCanCooperate("player", "target") and UnitIsPlayer("target") and not UnitPlayerOrPetInParty("target") and not UnitPlayerOrPetInRaid("target") then
			local member=GetMember("target")
			if member then 
				member.group=9
				tinsert(party,member)
			end
		end
		
		
		savedParty=party
		savedPlayerMember=playerMember
		
		-- Cleanup BOM.PlayerBuffs
		for name,val in pairs(BOM.PlayerBuffs) do
			local ok=false
			for i,member in ipairs(party) do
				if member.name==name then
					ok=true
				end
			end
			if ok==false then
				BOM.PlayerBuffs[name]=nil
			end
		end
		
	end
	
	BOM.PartyUpdateNeeded=false
	
	
	BOM.SomeBodyGhost=false
	local zonePlayer=C_Map.GetBestMapForUnit("player")
	
	local bi=0	
	for i,member in ipairs(party) do
		member.isPlayer=(member==playerMember)
		member.isDead=UnitIsDeadOrGhost(member.unitId) and not UnitIsFeignDeath(member.unitId)
		member.isGhost=UnitIsGhost(member.unitId)
		member.isConnected=UnitIsConnected(member.unitId)
		member.isSameZone=(C_Map.GetBestMapForUnit(member.unitId)==zonePlayer) or member.isGhost or member.unitId=="target"
		member.NeedBuff=true
		if not member.isDead or BOM.DeclineHasResurrection then
			member.hasResurrection=false
		else
			member.hasResurrection=UnitHasIncomingResurrection(member.unitId) or member.hasResurrection
		end		
		
		if member.buffs==nil then
			member.buffs={}
		else
			wipe(member.buffs)
		end
		
		BOM.SomeBodyGhost=BOM.SomeBodyGhost or member.isGhost

		if member.isDead then
			BOM.PlayerBuffs[member.name]=nil
		else
			member.distance=BOM.Tool.UnitDistanceSquared(member.unitId)
			member.hasArgentumDawn=false
			member.hasCarrot=false
			for buffIndex =1,BOM.MAXAURAS do 
				local name, icon, count, debuffType, duration, expirationTime, source, isStealable, 
					nameplateShowPersonal, spellId, canApplyAura, isBossDebuff, castByPlayer, nameplateShowAll, timeMod = BOM.UnitAura(member.unitId, buffIndex,"HELPFUL")
				
				if BOM.SpellToSpell[spellId] then
					spellId=BOM.SpellToSpell[spellId]
				end
				
				if spellId then
					if tContains( BOM.BuffIgnoreAll,spellId) then
						wipe(member.buffs)
						member.NeedBuff=false
						break
					end
				
					if spellId==BOM.ArgentumDawn.spell then
						member.hasArgentumDawn =true
					end
				
					if spellId==BOM.Carrot.spell then
						member.hasCarrot =true
					end
					
					if tContains(BOM.AllSpellIds,spellId) then
						bi=bi+1
						if buffCache[bi]==nil then buffCache[bi]={} end
						buffCache[bi].duration=duration
						buffCache[bi].expirationTime=expirationTime
						buffCache[bi].source=source
						buffCache[bi].isSingle=BOM.SpellIdIsSingle[spellId]
						member.buffs[BOM.SpellIdtoConfig[spellId]]=buffCache[bi]
					end
				end
			end
		end
	end
	
	-- weapon-buffs
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, mainHandEnchantID, hasOffHandEnchant, offHandExpiration, offHandCharges, offHandEnchantId = GetWeaponEnchantInfo()
	if hasMainHandEnchant and mainHandEnchantID and BOM.EnchantToSpell[mainHandEnchantID] then
		local configId=BOM.EnchantToSpell[mainHandEnchantID]
		bi=bi+1
		if buffCache[bi]==nil then buffCache[bi]={} end
		
		if BOM.ConfigToSpell[ConfigID] and BOM.ConfigToSpell[ConfigID].singleDuration then
			buffCache[bi].duration=BOM.ConfigToSpell[ConfigID].singleDuration
		else
			buffCache[bi].duration=300
		end
		
		buffCache[bi].expirationTime=mainHandExpiration
		buffCache[bi].source="player"
		buffCache[bi].isSingle=true
		playerMember.buffs[configId]=buffCache[bi]		
	end
	
	
	BOM.DeclineHasResurrection=false
	table.sort(party,function (a,b) return a.distance < b.distance or (a.distance==b.distance and a.name<b.name) end)
	
	return party,playerMember
end

function BOM.GetNeedBuff(party,spell,playerMember)
	spell.NeedMember=spell.NeedMember or {}
	spell.NeedGroup=spell.NeedGroup or {}
	spell.DeathGroup=spell.DeathGroup or {}
	wipe(spell.NeedGroup)
	wipe(spell.NeedMember)
	wipe(spell.DeathGroup)
	local SomeBodyDeath=false
	
	if spell.isInfo then
		for i,member in ipairs(party) do
			if member.buffs[spell.ConfigID] then
				tinsert(spell.NeedMember,member)
			end
		end
	elseif spell.isOwn then
		if not playerMember.isDead then
			if spell.ItemLock then
				if IsSpellKnown(spell.singleId) and not BOM.HasItem(spell.ItemLock) then
					tinsert(spell.NeedMember,playerMember)
				end		
			elseif not (playerMember.buffs[spell.ConfigID] and BOM.TimeCheck(playerMember.buffs[spell.ConfigID].expirationTime,playerMember.buffs[spell.ConfigID].duration)) then
				tinsert(spell.NeedMember,playerMember)			
			end
		end
		
	elseif spell.isResurrection then
		for i,member in ipairs(party) do
			if member.isDead and not member.hasResurrection and member.isConnected and member.group~=9 and (not BOM.DB.SameZone or member.isSameZone) then
				tinsert(spell.NeedMember,member)
			end
		end	
		
	elseif spell.isTracking then
		if GetTrackingTexture()~=spell.TrackingIcon and (BOM.ForceTracking==nil or BOM.ForceTracking==spell.TrackingIcon) then
			tinsert(spell.NeedMember,playerMember)			
		end	
		
	elseif spell.isAura then
		if BOM.ActivAura ~= spell.ConfigID and (BOM.CurrentProfile.LastAura==nil or BOM.CurrentProfile.LastAura==spell.ConfigID) then
			tinsert(spell.NeedMember,playerMember)			
		end	

	elseif spell.isSeal then
		if BOM.ActivSeal ~= spell.ConfigID and (BOM.CurrentProfile.LastSeal==nil or BOM.CurrentProfile.LastSeal==spell.ConfigID) then
			tinsert(spell.NeedMember,playerMember)			
		end	
	
	elseif spell.isBlessing then
		for i,member in ipairs(party) do
			local ok=false
			local notGroup=false
			
			if BOM.CurrentProfile.Spell[BOM.BLESSINGID][member.name]==spell.ConfigID or 
				(member.isTank and BOM.CurrentProfile.Spell[spell.ConfigID].Class["tank"] and not BOM.CurrentProfile.Spell[spell.ConfigID].SelfCast) then
				ok=true
				notGroup=true
			
			elseif BOM.CurrentProfile.Spell[BOM.BLESSINGID][member.name]==nil then 
				if BOM.CurrentProfile.Spell[spell.ConfigID].Class[member.class] and (not IsInRaid() or BOM.WatchGroup[member.group]) and not BOM.CurrentProfile.Spell[spell.ConfigID].SelfCast then
					ok=true
				end
				if BOM.CurrentProfile.Spell[spell.ConfigID].SelfCast and UnitIsUnit(member.unitId,"player") then
					ok=true
				end
			end

			if member.NeedBuff and ok and member.isConnected and (not BOM.DB.SameZone or member.isSameZone) then
				local found=false				
				
				if member.isDead then
					if member.group~=9 and member.class~="pet" then
						SomeBodyDeath=true	
						spell.DeathGroup[member.class]=true
					end
				elseif member.buffs[spell.ConfigID] then	
					found=BOM.TimeCheck(member.buffs[spell.ConfigID].expirationTime, member.buffs[spell.ConfigID].duration) 					
				end
								
				if not found then
					tinsert(spell.NeedMember,member)
					if not notGroup then
						spell.NeedGroup[member.class]=(spell.NeedGroup[member.class] or 0)+1
					end
				elseif not notGroup and BOM.DB.ReplaceSingle and member.buffs[spell.ConfigID] and member.buffs[spell.ConfigID].isSingle then
					spell.NeedGroup[member.class]=(spell.NeedGroup[member.class] or 0)+1
				end	
								
			end
		end
		
	else
		--spells
		for i,member in ipairs(party) do
			local ok=false
					
			if BOM.CurrentProfile.Spell[spell.ConfigID].Class[member.class] and (not IsInRaid() or BOM.WatchGroup[member.group]) and not BOM.CurrentProfile.Spell[spell.ConfigID].SelfCast then
				ok=true
			end
			if BOM.CurrentProfile.Spell[spell.ConfigID].SelfCast and UnitIsUnit(member.unitId,"player") then
				ok=true
			end
			if BOM.CurrentProfile.Spell[spell.ConfigID].ForcedTarget[member.name] then
				ok=true
			end
			if member.isTank and BOM.CurrentProfile.Spell[spell.ConfigID].Class["tank"] and not BOM.CurrentProfile.Spell[spell.ConfigID].SelfCast then
				ok=true
			end
		
			if member.NeedBuff and ok and member.isConnected and (not BOM.DB.SameZone or member.isSameZone) then
				local found=false
				
				if member.isDead then
					SomeBodyDeath=true	
					spell.DeathGroup[member.group]=true
					
				elseif member.buffs[spell.ConfigID] then	
					found=BOM.TimeCheck(member.buffs[spell.ConfigID].expirationTime, member.buffs[spell.ConfigID].duration) 					
				end
				
				if not found then
					tinsert(spell.NeedMember,member)
					spell.NeedGroup[member.group]=(spell.NeedGroup[member.group] or 0)+1
				elseif BOM.DB.ReplaceSingle and member.buffs[spell.ConfigID] and member.buffs[spell.ConfigID].isSingle then
					spell.NeedGroup[member.group]=(spell.NeedGroup[member.group] or 0)+1
				end	
				
				
			end
		end
	end
	
	-- Check Spell CD
	if spell.hasCD and #spell.NeedMember>0 then 
		local startTime,duration=GetSpellCooldown(spell.singleId)
		if duration~=0 then
			wipe(spell.NeedGroup)
			wipe(spell.NeedMember)
			wipe(spell.DeathGroup)
			startTime=startTime+duration
			if BOM.MinTimer>startTime then
				BOM.MinTimer=startTime
			end
			SomeBodyDeath=false
		end
	end
	
	
	return SomeBodyDeath
end

function BOM.UpdateMacro(member,spellId,command)
	if (GetMacroInfo(BOM.MACRONAME))==nil then
		local perAccount, perChar = GetNumMacros()
		local isChar=nil
		if perChar<MAX_CHARACTER_MACROS then
			isChar=1
		elseif perAccount>=MAX_ACCOUNT_MACROS then
			print(BOM.MSGPREFIX.. L.MsgNeedOneMacroSlot)
			return
		end			
		--print ("generate macro",isChar)
		CreateMacro(BOM.MACRONAME, BOM.Icon,"",isChar)
	end
	
	local macroText,icon
	if member and spellId then	
	
		--Downgrade-Check
		local spell=BOM.ConfigToSpell[spellId]		
		local rank=""
		if spell==nil then
			print("NIL SPELL:",spellId)
		end
		if BOM.DB.UseRank or member.unitId=="target" then 
			local level=UnitLevel(member.unitId)
			if spell and level~=nil and level>0 then 
				local x
				if spell.singleFamily and tContains(spell.singleFamily,spellId) then  		
					x=spell.singleFamily
				elseif spell.groupFamily and tContains(spell.groupFamily,spellId) then
					x=spell.groupFamily
				end
				if x then
					local newSpellId
					--print("Dodowngrade",spell.DownGrade[member.name])				
					for i,id in ipairs(x) do
						--print(id)
						if BOM.DB.SpellGreatherEqualThan[id]==nil or BOM.DB.SpellGreatherEqualThan[id]<level then
							newSpellId=id
						else
							break
						end
						if id==spellId then
							break
						end
						--print(newSpellId,spellId,"Set")
					end
					spellId=newSpellId or spellId											
				end
			end
			rank=GetSpellSubtext(spellId) or ""
			if rank~="" then
				rank="("..rank..")"
			end				
			--prsint("Use",GetSpellInfo(spellId),rank,spellId)
		end
		
		BOM.ERRSpellId=spellId
		local name = GetSpellInfo(spellId)
		
		macroText="#showtooltip\n/bom update\n"..
			(tContains(BOM.cancelForm,spellId) and "/cancelform [nocombat]\n" or "" )..
			"/bom _checkforerror\n"..
			"/cast [@"..member.unitId ..",nocombat]".. name..rank .."\n"
		icon=BOM.Icon
	else
		macroText="#showtooltip\n/bom update\n"
		if command then
			macroText=macroText.. command
		end
		icon=BOM.IconOff
	end

	EditMacro(BOM.MACRONAME,nil,icon,macroText)	
	BOM.MinimapButton.SetTexture("Interface\\ICONS\\"..icon)
end

local function GetGroupInRange(SpellName,party,groupNb,spell)
	local minDist
	local ret=nil
	for i,member in ipairs(party) do
		if member.group==groupNb then
			if not (IsSpellInRange(SpellName,member.unitId)==1 or member.isDead) then
				if member.distance>2000 then
					return nil
				end				
			elseif (minDist==nil or member.distance<minDist) and not tContains(spell.SkipList,member.name) then
				minDist=member.distance
				ret=member
			end
		end
	end
	return ret
end
local function GetClassInRange(SpellName,party,class,spell)
	local minDist
	local ret=nil
	for i,member in ipairs(party) do
		if member.class==class then
			if member.isDead then
				return nil
			elseif not (IsSpellInRange(SpellName,member.unitId)==1) then
				if member.distance>2000 then
					return nil
				end				
			elseif (minDist==nil or member.distance<minDist) and not tContains(spell.SkipList,member.name) then
				minDist=member.distance
				ret=member
			end
		end
	end
	return ret
end

function BOM.TimeCheck(ti,duration)
	if ti==nil or duration==nil or ti==0 or duration==0 then return true end
	local dif
	if duration<=60 then
		dif=BOM.DB.Time60
	elseif duration<=300 then
		dif=BOM.DB.Time300
	elseif duration<=600 then
		dif=BOM.DB.Time600
	elseif duration<=1800 then
		dif=BOM.DB.Time1800
	else
		dif=BOM.DB.Time3600
	end
	if dif+GetTime() < ti then
		ti=ti-dif
		if ti<BOM.MinTimer then
			BOM.MinTimer=ti
		end
		return true
	end
	
	return false
end

local displayCache={}
local display={}
local displayInfo={}
local displayI
local function AddDisplay(text,distance,isInfo)
	displayI=displayI+1
	displayCache[displayI] = displayCache[displayI] or {}
	displayCache[displayI][1]=text
	displayCache[displayI][2]=distance
	if not isInfo then 
		tinsert(display,displayCache[displayI])
	else
		tinsert(displayInfo,displayCache[displayI])
	end
end
local function ClearDisplay()
	BuffOmat_ListTab_MessageFrame:Clear()
	displayI=0
	wipe(display)
	wipe(displayInfo)
end

local function OutputDisplay()
	table.sort(display,function (a,b) return a[2] > b[2] or (a[2]==b[2] and a[1]>b[1]) end)
	table.sort(displayInfo,function (a,b) return a[1] > b[1] end)
	
	for i,txt in ipairs(displayInfo) do
		BuffOmat_ListTab_MessageFrame:AddMessage(txt[1])
	end	
	for i,txt in ipairs(display) do
		BuffOmat_ListTab_MessageFrame:AddMessage(txt[1])
	end	
end


local cast={}
local PlayerMana
local function CatchSpell(cost,id,link,member,spell)
	if cost > PlayerMana then
		return
	end

	if not spell.isResurrection and member.isDead then
		return
	elseif cast.Spell and not spell.isTracking then
		if cast.Spell.isTracking then
			return
		elseif spell.isResurrection then 
			if cast.Spell.isResurrection then		
				if	(tContains(ManaClass,cast.Member.class) and not tContains(ManaClass,member.class)) or
					(not cast.Member.isGhost and member.isGhost) or 
					(cast.Member.distance < member.distance) then
					return
				end		
			end
		else
			if not (BOM.DB.SelfFirst and not cast.Member.isPlayer and member.isPlayer) and not (cast.Member.group==9 and member.group~=9) and cast.manaCost>cost then
				return
			elseif (BOM.DB.SelfFirst and cast.Member.isPlayer and not member.isPlayer) or (cast.Member.group~=9 and member.group==9) then
				return
			end
		end
	end
		
	cast.manaCost=cost
	cast.SpellId=id
	cast.Link=link
	cast.Member=member
	cast.Spell=spell

end
local function ClearSpell()
	cast.manaCost=-1
	cast.SpellId=nil
	cast.Member=nil
	cast.Spell=nil
	cast.Link=nil
end
function BOM.UpdateScan()
	if BOM.Spells==nil then return end
	
	BOM.MinTimer=GetTime()+36000 -- 10 hours
	
	ClearDisplay()
	
	if InCombatLockdown() then
		BOM.ForceUpdate=false
		BOM.RepeatUpdate=false
		BOM.CheckForError=false	
		BuffOmat_ListTab_Button:SetText(L.MsgCombat)
		--BuffOmat_ListTab_Button:Disable() combatlock -imposible!
		return 
	end	
	if UnitIsDeadOrGhost("player") then
		BOM.ForceUpdate=false
		BOM.RepeatUpdate=false
		BOM.CheckForError=false	
		BOM.UpdateMacro()
		BuffOmat_ListTab_Button:SetText(L.MsgDead)	
		BuffOmat_ListTab_Button:Disable()
		BOM.AutoClose()
		return
	end
	local inInstance, instanceType = IsInInstance()
	local InDisabled
	
	local chooseProfile="solo"
	if IsInRaid() then
		chooseProfile="raid"
	elseif IsInGroup() then
		chooseProfile="group"
	end
	
	if instanceType=="pvp" or instanceType=="arena" then
		InDisabled=not BOM.DB.InPVP
		chooseProfile="battleground"
		
	elseif instanceType=="party" or instanceType=="raid" or instanceType=="scenario" then
		InDisabled=not BOM.DB.InInstance
	else
		InDisabled=not BOM.DB.InWorld
	end
	
	if BOM.ForceProfile then
		chooseProfile=BOM.ForceProfile
	end
	
	if not BOM.DBChar.UseProfiles then
		chooseProfile="solo"
	end
	
	if BOM.CurrentProfile ~= BOM.DBChar[chooseProfile] then
		BOM.CurrentProfile=BOM.DBChar[chooseProfile]
		BOM.UpdateSpellsTab()
		BuffOmat_MainWindow_Title:SetText(string.format(BOM.TxtEscapeIcon,BOM.FullIcon).." "..BOM.Title.." - "..L["profile_"..chooseProfile] )		
	end
	
	if InDisabled then
		BOM.CheckForError=false
		BOM.ForceUpdate=false
		BOM.RepeatUpdate=false
		BOM.UpdateMacro()
		BuffOmat_ListTab_Button:SetText(L.MsgDisabled)	
		BuffOmat_ListTab_Button:Disable()
		BOM.AutoClose()
		return
	end
	
	local party,playerMember=BOM.GetPartyMembers()
	
	--reset tracking
	BOM.ForceTracking=nil
	for i,spell in ipairs(BOM.Spells) do
		if spell.isTracking then 
			if BOM.CurrentProfile.Spell[spell.ConfigID].Enable then
				if spell.needForm~=nil then 
					if GetShapeshiftFormID()==spell.needForm and BOM.ForceTracking~=spell.TrackingIcon then
						BOM.ForceTracking=spell.TrackingIcon
						BOM.UpdateSpellsTab()						
					end
				elseif GetTrackingTexture()==spell.TrackingIcon and BOM.DBChar.LastTracking~=spell.TrackingIcon then
					BOM.DBChar.LastTracking=spell.TrackingIcon
					BOM.UpdateSpellsTab()
				end
			else
				if BOM.DBChar.LastTracking==spell.TrackingIcon and BOM.DBChar.LastTracking~=nil then
					BOM.DBChar.LastTracking=nil
					BOM.UpdateSpellsTab()
				end
			end	
		end
	end
	if BOM.ForceTracking==nil then
		BOM.ForceTracking=BOM.DBChar.LastTracking
	end
	
	--find activ aura / seal
	BOM.ActivAura=nil
	BOM.ActivSeal=nil
	
	for i,spell in ipairs(BOM.Spells) do
		if playerMember.buffs[spell.ConfigID] then 
			if spell.isAura then 
				if (BOM.ActivAura==nil and BOM.LastAura==spell.ConfigID) or UnitIsUnit(playerMember.buffs[spell.ConfigID].source,"player") then
					if BOM.TimeCheck(playerMember.buffs[spell.ConfigID].expirationTime,playerMember.buffs[spell.ConfigID].duration) then 
						BOM.ActivAura=spell.ConfigID
					end
				end					
			elseif spell.isSeal then 
				if UnitIsUnit(playerMember.buffs[spell.ConfigID].source,"player")  then
					if BOM.TimeCheck(playerMember.buffs[spell.ConfigID].expirationTime,playerMember.buffs[spell.ConfigID].duration) then 
						BOM.ActivSeal=spell.ConfigID
					end
				end
			end
		end
	end
	
	--reset aura/seal
	for i,spell in ipairs(BOM.Spells) do
		if spell.isAura then 
			if BOM.CurrentProfile.Spell[spell.ConfigID].Enable then
				if BOM.ActivAura==spell.ConfigID and BOM.CurrentProfile.LastAura~=spell.ConfigID then
					BOM.CurrentProfile.LastAura=spell.ConfigID
					BOM.UpdateSpellsTab()
				end
			else
				if BOM.CurrentProfile.LastAura==spell.ConfigID and BOM.CurrentProfile.LastAura~=nil then
					BOM.CurrentProfile.LastAura=nil
					BOM.UpdateSpellsTab()
				end
			end	
		elseif spell.isSeal then 
			if BOM.CurrentProfile.Spell[spell.ConfigID].Enable then
				if BOM.ActivSeal==spell.ConfigID and BOM.CurrentProfile.LastSeal~=spell.ConfigID then
					BOM.CurrentProfile.LastSeal=spell.ConfigID
					BOM.UpdateSpellsTab()
				end
			else
				if BOM.CurrentProfile.LastSeal==spell.ConfigID and BOM.CurrentProfile.LastSeal~=nil then
					BOM.CurrentProfile.LastSeal=nil
					BOM.UpdateSpellsTab()					
				end
			end	
		end
	end
	
	-- who needs a buff!
	local SomeBodyDeath=false	
	for i,spell in ipairs(BOM.Spells) do
		SomeBodyDeath=BOM.GetNeedBuff(party,spell,playerMember) or SomeBodyDeath
	end
	

	-- cancel buffs
	for i,spell in ipairs(BOM.CancelBuffs) do
		if BOM.CurrentProfile.CancelBuff[ spell.ConfigID].Enable and not spell.OnlyCombat  then
			if playerMember.buffs[spell.ConfigID] then
				print(BOM.MSGPREFIX,string.format(L.MsgCancelBuff,spell.singleLink or spell.single,UnitName(playerMember.buffs[spell.ConfigID].source or "") or ""))
				BOM.CancelBuff(spell.singleFamily)
			end
		end
	end
	
	-- fill list and find cast
	PlayerMana=UnitPower("player",0) or 0--mana
	BOM.ManaLimit=UnitPowerMax("player",0) or 0
	
	ClearSpell()
	
	local inRange=false
			
	for spellIndex,spell in ipairs(BOM.Spells) do
		
		if BOM.CurrentProfile.Spell[spell.ConfigID].Enable and (spell.needForm==nil or GetShapeshiftFormID()==spell.needForm) then
			if #spell.NeedMember>0 and not spell.isInfo then
				if spell.singleMana<BOM.ManaLimit and spell.singleMana>PlayerMana then
					BOM.ManaLimit=spell.singleMana
				end
				if spell.groupMana and spell.groupMana<BOM.ManaLimit and spell.groupMana>PlayerMana then
					BOM.ManaLimit=spell.groupMana
				end
			end
	
			if spell.isInfo then
				if #spell.NeedMember then
					for memberIndex,member in ipairs(spell.NeedMember) do
						AddDisplay(string.format(L["MsgBuffSingle"],member.link, spell.singleLink), member.distance,true)
					end
				end
				
			elseif (spell.isOwn or spell.isTracking or spell.isAura or spell.isSeal) then
				if #spell.NeedMember>0 then
					if (not spell.NeedOutdoors or IsOutdoors()) and not tContains(spell.SkipList,member.name)  then
						AddDisplay(string.format(L["MsgBuffSingle"],playerMember.link, spell.singleLink), playerMember.name)
						inRange=true
						
						CatchSpell(spell.singleMana,spell.singleId,spell.singleLink,playerMember,spell)
					else
						AddDisplay(string.format(L["MsgBuffSingle"],playerMember.name, spell.single), playerMember.name)
					end
				end				
			
			elseif spell.isResurrection then
				local clearskip=true
				for memberIndex,member in ipairs(spell.NeedMember) do
					if not tContains(spell.SkipList,member.name) then
						clearskip=false
						break
					end
				end
				if clearskip then
					wipe(spell.SkipList)
				end
			
				for memberIndex,member in ipairs(spell.NeedMember) do
					if not tContains(spell.SkipList,member.name) then
						local isInRange=(IsSpellInRange(spell.single,member.unitId)==1) and not tContains(spell.SkipList,member.name) 
						
						if isInRange then
							inRange=true
							AddDisplay(string.format(L["MsgBuffSingle"],member.link, spell.singleLink), member.name)
						else
							AddDisplay(string.format(L["MsgBuffSingle"],member.name,spell.single),member.name)
						end
											
						if isInRange or (BOM.DB.ResGhost and member.isGhost) then							
							CatchSpell(spell.singleMana,spell.singleId,spell.singleLink,member,spell)
						end
					end
				end
									
			elseif spell.isBlessing then
				--Group buff
				if spell.groupMana~=nil and not BOM.DB.NoGroupBuff then
					for i,groupIndex in ipairs(BOM.Tool.Classes) do
						if spell.NeedGroup[groupIndex] and spell.NeedGroup[groupIndex]>=BOM.DB.MinBlessing then	
							local Group=GetClassInRange(spell.group,spell.NeedMember,groupIndex,spell)
							if Group==nil then
								Group=GetClassInRange(spell.group,party,groupIndex,spell)									
							end
							
							if Group~=nil and (not spell.DeathGroup[member.group] or not BOM.DB.DeathBlock)  then 
								AddDisplay(string.format(L["MsgBuffGroup"],"|c"..RAID_CLASS_COLORS[groupIndex].colorStr .. BOM.Tool.ClassName[groupIndex].."|r",spell.groupLink or spell.group),"!"..groupIndex)	
								inRange=true
								
								CatchSpell(spell.groupMana,spell.groupId,spell.groupLink,Group,spell)
	
							else
								AddDisplay(string.format(L["MsgBuffGroup"],BOM.Tool.ClassName[groupIndex],spell.group),"!"..groupIndex)						
							end
							
						end
					end
				end
				
				-- SINGLE BUFF
				for memberIndex,member in ipairs(spell.NeedMember) do
				
					if not member.isDead and spell.singleMana~=nil and (BOM.DB.NoGroupBuff or spell.groupMana==nil or member.class=="pet" or spell.NeedGroup[member.class]==nil  or spell.NeedGroup[member.class]<BOM.DB.MinBlessing) then
						
						local add=""
						if BOM.CurrentProfile.Spell[BOM.BLESSINGID][member.name]~=nil then
							add=string.format(BOM.TxtEscapePicture,BOM.IconTargetOn)
						end
						
						
						local isInRange=(IsSpellInRange(spell.single,member.unitId)==1) and not tContains(spell.SkipList,member.name) 
						if isInRange then 
							AddDisplay(string.format(L["MsgBuffSingle"],add..member.link,spell.singleLink),member.name)
							inRange=true
							
							CatchSpell(spell.singleMana,spell.singleId,spell.singleLink,member,spell)
							
						else
							AddDisplay(string.format(L["MsgBuffSingle"],add..member.name,spell.single),member.name)
						end
						
						
					end
				end				
				
			else
			
				--Group buff
				if spell.groupMana~=nil and not BOM.DB.NoGroupBuff then
					for groupIndex=1,8 do
						if spell.NeedGroup[groupIndex] and spell.NeedGroup[groupIndex]>=BOM.DB.MinBuff then	
							local Group=GetGroupInRange(spell.group,spell.NeedMember,groupIndex,spell)
							if Group==nil then
								Group=GetGroupInRange(spell.group,party,groupIndex,spell)									
							end
							
							if Group~=nil and (not spell.DeathGroup[groupIndex] or not BOM.DB.DeathBlock)  then 
								AddDisplay(string.format(L["MsgBuffGroup"],groupIndex,spell.groupLink or spell.group),"!"..groupIndex)	
								inRange=true
								
								CatchSpell(spell.groupMana,spell.groupId,spell.groupLink,Group,spell)
	
							else
								AddDisplay(string.format(L["MsgBuffGroup"],groupIndex,spell.group),"!"..groupIndex)						
							end
							
						end
					end
				end
				-- SINGLE BUFF
				for memberIndex,member in ipairs(spell.NeedMember) do
				
					if not member.isDead and spell.singleMana~=nil and (BOM.DB.NoGroupBuff or spell.groupMana==nil or member.group==9 or spell.NeedGroup[member.group]==nil or spell.NeedGroup[member.group]<BOM.DB.MinBuff) then
						
						local add=""
						if BOM.CurrentProfile.Spell[spell.ConfigID].ForcedTarget[member.name] then
							add=string.format(BOM.TxtEscapePicture,BOM.IconTargetOn)
						end						
						
						local isInRange=(IsSpellInRange(spell.single,member.unitId)==1) and not tContains(spell.SkipList,member.name)
						if isInRange then 
							AddDisplay(string.format(L["MsgBuffSingle"],add..member.link,spell.singleLink),member.name)
							inRange=true
							
							CatchSpell(spell.singleMana,spell.singleId,spell.singleLink,member,spell)
							
						else
							AddDisplay(string.format(L["MsgBuffSingle"],add..member.name,spell.single),member.name)
						end
								
					end
				end				
				
			end
		end
	end	
	
	--BuffOmat_ListTab_MessageFrame:AddMessage(" ")
	
	-- check argent dawn
	do
		local name, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty, isDynamic, instanceID, instanceGroupSize, LfgDungeonID = GetInstanceInfo()
		if BOM.DB.ArgentumDawn then
			if playerMember.hasArgentumDawn ~= tContains(BOM.ArgentumDawn.dungeon,instanceID) then
				AddDisplay(BOM.ArgentumDawn.Link, playerMember.distance,true)
			end
		end
		if BOM.DB.Carrot then
			if playerMember.hasCarrot and not tContains(BOM.Carrot.dungeon,instanceID) then
				AddDisplay(BOM.Carrot.Link, playerMember.distance,true)
			end
		end
	end
	
	--enchantment on weapons
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, mainHandEnchantID, hasOffHandEnchant, offHandExpiration, offHandCharges, offHandEnchantId = GetWeaponEnchantInfo()
	if BOM.DB.MainHand and not hasMainHandEnchant then
		local link=GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
		if link then
			AddDisplay(link, playerMember.distance,true)
		end
	end
	if BOM.DB.SecondaryHand and not hasOffHandEnchant then
		local link=GetInventoryItemLink("player",GetInventorySlotInfo("SECONDARYHANDSLOT"))
		if link then 
			AddDisplay(link, playerMember.distance,true)			
		end
	end
	
	--itemcheck
	
	local ItemList=BOM.GetItemList(BOM.ItemList)
	local BagCommand
	local BagTitel
	for i,item in ipairs(ItemList) do
		local ok=false
		if item.CD then
			if (item.CD[1] or 0)~=0 then
				local ti=item.CD[1]+item.CD[2]-GetTime()+1				
				if ti<BOM.MinTimer then
					BOM.MinTimer=ti
				end
			elseif item.Link then			
				ok=true
			end
		elseif item.Lootable then
			ok=true
		end
		
		if ok then
			BagTitel=string.format(BOM.TxtEscapeIcon, item.Texture) .. item.Link
			BagCommand="/use "..item.Bag.." "..item.Slot
			AddDisplay(BagTitel,playerMember.distance,true)						
		end
	end
	
	
	if #display>0 or #displayInfo>0 then
		BOM.AutoOpen()
		--BuffOmat_ListTab_MessageFrame:AddMessage(string.format(L["MsgNextCast"],castMember.link or castMember.name,castLink or castSpell))

	else
		BOM.AutoClose()		
	end
	
	OutputDisplay()
	
	BOM.ForceUpdate=false
	
	if BOM.PlayerCasting then
		BuffOmat_ListTab_Button:SetText(L.MsgBusy)
		BOM.UpdateMacro()	
		BuffOmat_ListTab_Button:Disable()
		BOM.RepeatUpdate=true
	
	elseif cast.Member and cast.SpellId then				
		BuffOmat_ListTab_Button:SetText(string.format(L["MsgNextCast"],cast.Link, cast.Member.link))
				
		BOM.UpdateMacro(cast.Member,cast.SpellId)
		local cdtest=GetSpellCooldown(cast.SpellId) or 0
		if  cdtest~=0 then
			BOM.CheckCoolDown=cast.SpellId
			BuffOmat_ListTab_Button:Disable()
		else
			BuffOmat_ListTab_Button:Enable()
		end
		
		BOM.ERRSpell=cast.Spell
		BOM.ERRMember=cast.Member
				
		BOM.RepeatUpdate=true
	else
		if #display==0 then
			BuffOmat_ListTab_Button:SetText(L.MsgEmpty)			
			BOM.RepeatUpdate=false
			for spellIndex,spell in ipairs(BOM.Spells) do
				if #spell.SkipList>0 then 
					wipe(spell.SkipList)
				end
			end
			
		else
			if SomeBodyDeath and BOM.DB.DeathBlock then
				BuffOmat_ListTab_Button:SetText(L.MsgSomebodyDead)
			else
				--BuffOmat_ListTab_Button:SetText(L.MsgNoSpell)
				if inRange then
					BuffOmat_ListTab_Button:SetText(ERR_OUT_OF_MANA)
				else
					BuffOmat_ListTab_Button:SetText(ERR_SPELL_OUT_OF_RANGE)
					local skipreset=false
					for spellIndex,spell in ipairs(BOM.Spells) do
						if #spell.SkipList>0 then 
							skipreset=true
							wipe(spell.SkipList)							
						end
					end
					if skipreset then
						BOM.FastUpdateTimer()
						BOM.ForceUpdate=true						
					end
					
				end
				
			end
			BOM.RepeatUpdate=true
		end
		if BagTitel then
			BuffOmat_ListTab_Button:SetText(BagTitel)
		end
		BuffOmat_ListTab_Button:Enable()
		BOM.UpdateMacro(nil,nil,BagCommand)
	end
	
end

function BOM.ADDSKIP()
	if BOM.ERRSpell and BOM.ERRSpell.SkipList and BOM.ERRMember then 
		tinsert(BOM.ERRSpell.SkipList,BOM.ERRMember.name)
		BOM.FastUpdateTimer()
		BOM.ForceUpdate=true
	end
end
function BOM.DownGrade()
	if BOM.ERRSpell and BOM.ERRSpell.SkipList and BOM.ERRMember then 
		--print("downgrade",BOM.ERRSpellId)
		local level=UnitLevel(BOM.ERRMember.unitId)
		if level ~= nil and level>-1 then 
			if BOM.DB.SpellGreatherEqualThan[BOM.ERRSpellId]== nil or BOM.DB.SpellGreatherEqualThan[BOM.ERRSpellId]<level then
				BOM.DB.SpellGreatherEqualThan[BOM.ERRSpellId]=level
				BOM.FastUpdateTimer()
				BOM.ForceUpdate=true
				print(BOM.MSGPREFIX,string.format(L.MsgDownGrade,BOM.ERRSpell.single,BOM.ERRMember.name))
			elseif BOM.DB.SpellGreatherEqualThan[BOM.ERRSpellId]>=level then
				BOM.ADDSKIP()			
			end		
		else
			BOM.ADDSKIP()			
		end
	end
end

function BOM.ClearSkip()
	for spellIndex,spell in ipairs(BOM.Spells) do
		if spell.SkipList then
			wipe(spell.SkipList)
		end
	end
end

function BOM.BattleCancelBuffs()
	if BOM.Spells==nil or BOM.CurrentProfile==nil then return end
	for i,spell in ipairs(BOM.CancelBuffs) do
		if BOM.CurrentProfile.CancelBuff[ spell.ConfigID].Enable and BOM.CancelBuff(spell.singleFamily)then
			print(BOM.MSGPREFIX,string.format(L.MsgCancelBuff,spell.singleLink or spell.single,UnitName(BOM.CancelBuffSource) or ""))
		end
	end
end

function BOM.SpellHasClasses(spell)
	return not (spell.isOwn or spell.isResurrection or spell.isSeal or spell.isTracking or spell.isAura or spell.isInfo)
end
-- 0 0 1